/*
 * Copyright 2016 - 2021 gary@drinkingtea.net
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#pragma once

#include <functional>

#include <ox/std/string.hpp>
#include <ox/std/vector.hpp>

#include <nostalgia/core/context.hpp>

namespace nostalgia::studio {

struct EditorMaker {
	using Func = std::function<class Editor*(ox::String)>;
	ox::Vector<ox::String> fileTypes;
	Func make;
};

class Module {
	public:
		virtual ~Module() noexcept = default;

		virtual ox::Vector<EditorMaker> editors(core::Context *ctx);

};

}